/**************************************************************************

		    DCOMSTR.C Window Management

		Author: FB.DRUILHE
		Update: Jan 04, 1990

**************************************************************************/

#include <stdio.h>
#include <conio.h>
#include <dos.h>
#include <string.h>
#include <time.h>
#include <process.h>
#include "dcomstr.h"

#define FALSE 0
#define TRUE  !FALSE


extern int com_port;

extern void open_main_window(int clr);
extern void setup_com(int v);
extern void setup_user_speed(int v);
extern void setup_user_format(int v);
extern void setup_tx(int v);
extern void setup_rx(int v);
extern void setup_com_ports();
extern void sys_error(char *mes);
extern void exec_test_menu();
extern void enable_it_com();

extern cursof();
extern curson();

/* Speed Str */
extern char com_speed_str[2][12];
extern char user_speed_str[2][12];

struct choix master_menu = {
	1, 7, FALSE,
	20, 1, 54, 9, FALSE,
	BLACK, WHITE, RED,
        " MAIN MENU ",
	"Pedefined Keys",
	"Save Configuration",
	"Recover Configuration",
	"Select Interpretor",
	"DOS Gateway",
	"Automatic Test",
	"EXIT to DOS            Alt-X" };

struct choix tx_menu = {
	1, 9, FALSE,
	30, 1, 52, 11, TRUE,
	BLACK, WHITE, YELLOW,
	" TRANSMIT SOURCE ",
	"Keyboard",
	"QBF1",
	"QBF2",
	"File",
	"AAAAAAAA",
	"UUUUUUUU",
	"",
	"",
	"xxxxxxxx",
	};

struct choix rx_menu = {
	1, 3, FALSE,
	30, 2, 55, 6, TRUE,
	BLACK, WHITE, YELLOW,
	" RECEIVE DESTINATION ",
	"Screen",
	"QBF1 Error Count",
	"none"
	};

struct choix end_menu = {
	1, 2, FALSE,
	30, 15, 47, 18, FALSE,
	BLACK, WHITE, RED,
	" EXIT to DOS ",
	"NO",
	"YES"
	};

struct choix time_menu = {
	2, 2, FALSE,
	15, 11, 57, 14, FALSE,
	BLACK, WHITE, RED,
	" TIME and DATE ",
	"",
	""
	};

char err_buff[2][50*4*2]; /* Error Buffer */

struct choix error_window = {
	1, 1, FALSE,
	10, 0, 57, 0, FALSE,
	BLACK, WHITE, YELLOW,
	" QBF1 ERROR COUNT ",
	""
	};

#define N_KEY 20

char key[N_KEY][75] = {"Key 1", "Key 2", "Key 3", "Key 4", "Key 5",
		       "Key 6", "Key 7", "Key 8", "Key 9", "Key 0",
			     /* Other Key have special Function */
		       ""               /* use for Tx File Name */,
		       "DCOM.SET"              /* use for SetUp */,
		       ""                /* use for Dos GateWay */,
		       ""                        /* Interpretor */,
		       "DCOM0000.TST"         /* Test File Name */,
		       ""                           /* not Used */,
		       "DCOM*.TST"     /* Generic Name for Test */,
		       "DCOM.RES"      /* Results File for Test */,
		       ""             /* Line Simulator Program */,
		       ""        /* Generic Name for Line Setup */
		    };

struct choix key_menu = {
	1, 10, FALSE,
	1, 2, 80, 13, FALSE,
	BLACK, WHITE, YELLOW,
	" PREDEFINED KEYS ",
	key[0], key[1], key[2], key[3], key[4],
	key[5], key[6], key[7], key[8], key[9]	};

char new_string[75];

struct choix str_menu = {
	1, 1, FALSE,
	1, 17, 80, 19, FALSE,
	BLACK, WHITE, RED,
	"",
	new_string
	};

time_t secs_now, secs_elaps;
int first_time = TRUE;

/************************** MENU MANAGEMENT **********************************/

void open_window( c, b, clr)
struct choix *c;
char *b;
int clr;
{
	int i, x0, y0, xm, ym;
	x0=c->c_x;  y0=c->c_y;
	xm=c->c_sx; ym=c->c_sy;

	if (c->c_of)
	  {
	  if (com_port==1)
	    { y0+=12; ym+=12; }
	  }
	/* Save Screen */
	if (clr) gettext( x0, y0, xm, ym, b  );
	/* Open Window */
	window( x0, y0, xm, ym  );
	textbackground( c->c_background );
	textcolor( c->c_textcolor );
	if (clr) clrscr();
	/* Box */
	  {
	  char tb[2];
	  gotoxy(1, ym-y0+1); cprintf("");
	  for (i=2; i<(xm-x0+1); i++) cprintf("");
	  tb[0]=''; tb[1]=(c->c_background<<4)+c->c_textcolor;
          puttext(xm, ym, xm, ym, tb);
/*	  cprintf("");               */
	  gotoxy(1,1); cprintf("");
	  for (i=2; i<(xm-x0+1); i++) cprintf("");
	  cprintf("");
	  for (i=2;i<=(ym-y0); i++)
	    {
	    gotoxy(1, i);
	    cprintf("");
	    gotoxy((c->c_sx-c->c_x+1), i);
	    cprintf("");
	    }
	  }

	/* Title */
	gotoxy(3, 1);
	textcolor( c->c_textselect);
	cprintf("%s", c->c_menu );
	textcolor( c->c_textcolor);

}

void close_window( c, b)
struct choix *c;
char *b;
{
	int i, x0, y0, xm, ym;
	x0=c->c_x;  y0=c->c_y;
	xm=c->c_sx; ym=c->c_sy;

	if (c->c_of)
	  {
	  if (com_port==1)
	    { y0+=12; ym+=12; }
	  }
	/* Recover Screen */
	puttext( x0, y0, xm, ym, b  );
}

void affiche_select( c, i, res )
struct choix *c;
int i;
{
	  gotoxy(1, i+1);
	  cprintf("");
	  if (i==res)
	    {
	    textbackground( c->c_textcolor );
	    textcolor( c->c_background );
	    }
	  else
	    textcolor( c->c_textcolor );
	  clreol();
	  if ((i==c->c_value)&&c->c_flg) cprintf("  ");
	  else cprintf("   ");
	  cprintf("%s", c->c_select[i-1]);
	  textcolor( c->c_textcolor );
	  textbackground( c->c_background );
	  gotoxy((c->c_sx-c->c_x+1), i+1);
	  cprintf("");
	  gotoxy(1, 1);
}

void affiche_single( c, i)
struct choix *c;
int i;
{
	  gotoxy(1, i+1);
	  cprintf("");
	  textcolor( c->c_textcolor );
	  cprintf("%s", c->c_select[i-1]);
	  gotoxy((c->c_sx-c->c_x+1), i+1);
	  cprintf("");
}

int setup_str( char *str_in, char *title)
{
	int end_loop;
	int escape=0;
	int insert=FALSE;
	int cx;
	char ch;
	char buff[80*25*2];
	struct choix *c = &str_menu;
	c->c_menu=title;

          open_window( c, buff, TRUE);
	  /* gotoxy(3, 1);
	  cprintf("%s", title); */
	  strcpy(new_string, str_in);
	  curson();
	  cx=strlen(new_string);
	  do
	    {
	    int l;
	    affiche_select( c, 1, 0);
	    l=strlen(new_string);
	    gotoxy(cx+5, 2);
	    escape=   ( (ch=getch()) == 27);
	    end_loop= ( (ch==13) || escape);
	    if (ch==0)
	      {
	      ch=getch();
	      if (ch==75) if (cx)   cx--;
	      if (ch==77) if (cx<l) cx++;
	      if (ch==82) insert=~insert;
	      if (ch==71) cx=0;
	      if (ch==79) cx=l;
	      }
	    else if (!end_loop)
	      {
	      if (ch==8) /* BS */
		{
		if (cx)
		  {
		  int ii;
		  for (ii=cx;ii<l;ii++) new_string[ii-1]=new_string[ii];
		  new_string[l-1]=0x00;
		  cx--;
		  }
		}
	      else
		{
		if (insert)
		  {
		  int ii;
		  for (ii=l+1;ii>cx;ii--) new_string[ii]=new_string[ii-1];
		  }
		new_string[cx++]=ch;
		if (cx>=l) new_string[cx]=0x00;
		}
	      }
	    } while (!end_loop);
	    cursof();
	  if (!escape) strcpy(str_in, new_string);
	  close_window( c , buff);
	if (!escape) return(1); else return(0);
}

int setup_key( int v, char *title)
{
	if (v)
	  {
	  if (setup_str(key[v-1], title)) return(v);
	  else return(0);
	  } return(0);
}

int affiche_choix( c )
struct choix *c;
{
	int res=c->c_value; /* Initial Value */
	int end_loop, escape;
	char buff[80*25*2];
        open_window( c, buff, TRUE);
	/* Write Menu */
	do {
	   int i, ch;
	   for (i=1;i<=c->c_max;i++) affiche_select( c, i, res);
	   escape=( (ch=getch()) == 27);
	   end_loop= ( (ch==13) || escape);
	   if (ch==0)
	     {
	     ch=getch();
	     if ((ch==80)&&(res<c->c_max)) res++;
	     if ((ch==72)&&(res>1)) res--;
	     if ((ch==81)||(ch==79)) res=c->c_max;
	     if ((ch==73)||(ch==71)) res=1;
	     }
	   } while (!end_loop);
	close_window(c, buff);
	if (!escape) c->c_value=res;
	else res=0;
	return(res);
}

void exec_dos_command()
/* Execute a Dos Command */
{
	char buff[80*25*2];

	if (setup_key(13, " Enter DOS Command "))
	  {
	  /* Save Screen */
	  gettext( 1, 1, 80, 25, buff  );
	  /* Open Window */
	  curson();
	  window( 1, 1, 80, 25 );
	  textbackground( BLACK );
	  textcolor( WHITE );
	  clrscr();

	  /* Execute DOS Command */
	  if (system(key[12]))
	    sys_error("CANNOT EXECUTE");
	  else
	    {

	    /* Wait until CR */
	    printf("\n<<Press CR to go back to DCOM>>");
	    while (getch()!=13);
	    }

	  /* Recover Screen */
	  cursof();
	  puttext( 1, 1, 80, 25, buff  );
	  gotoxy(1, 1);
	  /* Restore COM_SetUp */
	  setup_com_ports();
	  enable_it_com();
          }
}

void exec_interpretor()
{
	char buff[80*25*2];
	char t[80];

	/* Save Screen */
	gettext( 1, 1, 80, 25, buff  );
	/* Open Window */
	curson();
	window( 1, 1, 80, 25 );
	textbackground( BLACK );
	textcolor( WHITE );
	clrscr();

	/* Compose Interpretor */
	sprintf(t,"%s /%u",key[13],com_port);
	/* printf("\n\n[%s]\n\n", t); */

	if (system(t)) sys_error("CANNOT EXECUTE INTERPRETOR");

	/* Recover Screen */
	cursof();
	puttext( 1, 1, 80, 25, buff  );
	gotoxy(1, 1);
	/* Restore COM_SetUp */
	setup_com_ports();
	enable_it_com();
}

void save_key()
{
	int i;
	FILE *skey;

	if (setup_key(12, " Enter File Name "))
	  {
          skey = fopen( key[11], "wt");
	  if (skey==NULL)
	    {
	    sys_error("CANNOT OPEN FILE");
	    }
	  else
	    {
	    for (i=0;i<N_KEY;i++) fprintf(skey, "%s\n", key[i]);
	    for (i=0;i<2;i++) fprintf(skey,"%s\n",com_speed_str[i]);
	    for (i=0;i<2;i++) fprintf(skey,"%s\n",user_speed_str[i]);
	    fclose(skey);
	    }
	  }
}

void select_interpretor()
{
	setup_key(14, " Enter Interpretor Name ");
}

int load_string(FILE *sk, char *str)
{
	int i;
	char c;
	strcpy(str, "");
	while ((c=getc(sk)) !=EOF)
	      {
	      if (c==0x0a) return(0);
	      else strncat(str, &c, 1);
	      }
	return(TRUE);
}

void restore_init_key()
{
	FILE *skey;

          skey = fopen( key[11], "rt");
	  if (skey==NULL)
	    {
	    char ERR[50];
	    sprintf(ERR, "CANNOT OPEN FILE %s", key[11]);
	    sys_error(ERR);
	    }
	  else
	    {
	    int i;
	    for (i=0;i<N_KEY;i++) load_string( skey, key[i]);
	    load_string( skey, com_speed_str[0]);
	    load_string( skey, com_speed_str[1]);
	    load_string( skey, user_speed_str[0]);
	    load_string( skey, user_speed_str[1]);
	    fclose(skey);
	    }
}

void restore_key()
{
	if (setup_key(12, " Enter File Name "))
	  {
	  restore_init_key();
	  }
}

void affiche_time()
{
	int end_loop=FALSE;
	char buff[80*25*2];
	struct tm *tm_now;
	double delta_time;
	char str_now[80], str_elap[80], str_tmp[20];
	struct choix *c = &time_menu;

        open_window( c, buff, TRUE);
	/* Menu */
	do {
	   int i, ch;
	   int heure, minute, seconde;

	   time(&secs_now);
	   if (first_time)
	     {
	     time(&secs_elaps);
	     first_time=FALSE;
	     }
           strcpy(str_now,  " Current Date : ");
	   strcat(str_now, ctime(&secs_now));
	   c->c_select[0]= str_now;
	   delta_time=difftime(secs_now, secs_elaps);
	   strcpy(str_elap, " Elapsed Time : ");
	   sprintf(str_tmp, "%6ld sec ", (long int) delta_time);
	   strcat(str_elap, str_tmp);
	   heure= delta_time/3600;
	   minute=(delta_time -(3600*heure))/60;
	   seconde=(delta_time -(3600*heure) -(60*minute));
	   sprintf(str_tmp, "%2u:%0.2u:%0.2u ", heure, minute, seconde);
	   strcat(str_elap, str_tmp);
	   c->c_select[1]= str_elap;
           /* if (affiche_choix(c) == 2) time(&secs_elaps); */

	   for (i=1;i<=c->c_max;i++) affiche_single( c, i);

	   if (kbhit())
	     {
	     char ch;
	     ch=getch();
	     if (ch==27) end_loop=TRUE;
	     if (ch==13) first_time=TRUE;
	     }
	   } while (!end_loop);
	close_window( c, buff);
}

void open_error_window( int ic, int clr )
{
	struct choix *c = &error_window;

	if (ic==0) { c->c_y = 19; c->c_sy = 21; }
	else       { c->c_y =  7; c->c_sy =  9; }
        if (clr)
	  {
	  open_window( c, err_buff[ic], clr);
 	  affiche_select( c, 1, 2);
	  }
	else
	  {
	  int i, x0, y0, xm, ym;
	  x0=c->c_x;  y0=c->c_y;
	  xm=c->c_sx; ym=c->c_sy;

  	  /* Open Window */
	  window( x0, y0, xm, ym  );
	  textbackground( c->c_background );
	  textcolor( c->c_textcolor );
	  /* Move cursor */
	  gotoxy(3,2);
	  }
}

void close_error_window(int ic)
{
	struct choix *c = &error_window;
	if (ic==0) { c->c_y = 19; c->c_sy = 21; }
	else       { c->c_y =  7; c->c_sy =  9; }
	close_window(c, err_buff[ic]);
}

choix_setup_tx()
{
	setup_tx( affiche_choix(&tx_menu) );
}

choix_setup_rx()
{
	setup_rx( affiche_choix(&rx_menu) );
}

void confirm_exit()
{
	setup_end_prog(    affiche_choix(&end_menu)    );
}

void select_setup()
{	int i, sx, sy;
	sx=wherex(); sy=wherey();
	do {
	   i=affiche_choix(&master_menu);

	   if (i==1)
		{
		int j;
		char tk[80];
		j=affiche_choix(&key_menu);
		if (j)
		  {
                  sprintf(tk, " Enter Key Specification <ALT-%u> ", j);
		  setup_key( j, tk);
		  }
		}
	   if (i==2)  save_key();
	   if (i==3)  restore_key();
	   if (i==4)  select_interpretor();
	   if (i==5)  exec_dos_command( );
	   if (i==6)  exec_test_menu( );
	   if (i==7)  confirm_exit();
	   } while ((i!=0)&&(i!=7));
	open_main_window(0 /* no CLEAR */);
	gotoxy(sx, sy);
}

